#!/usr/bin/perl

use strict;

my $conf = "/var/named/chroot/etc/named.conf";


if ($ARGV[0] =~ /list/)
{
	get_dns_forwarder();
}
elsif($ARGV[0])
{
	set_dns_forwarder();
}
else
{
	set_dns_forwarder(1);
}

sub get_dns_forwarder
{
	open(CONF, "<$conf");
	foreach my $line (<CONF>)
	{
		if ($line  =~ /forwarders\s*{\s*(\d{1,3}\.\d{1,3}.\d{1,3}.\d{1,3});/)
		{
			print $1;
			last;
		}
	}
}

sub set_dns_forwarder
{
    my $remove = shift;
    
    open(CONF, "<$conf");
    my @data = <CONF>;
    close(CONF);
    
    my $lines = join("", @data);
    
    if ($remove)
    {
	# remove any concept of a forwarder
	$lines =~ s/\s*options\s*{.*forwarders\s*{.*?};/\noptions {/s;
    }
    else
    {
	# set the forwarder to the ip passed in as an arg
	
	my ($result) = $lines =~ s/\s*options\s*{.*forwarders\s*{.*?};/\noptions {\n\tforwarders { $ARGV[0]; };/s;
										  
	unless($result)
	{
	    $lines =~ s/\s*options\s*{/\noptions {\n\tforwarders { $ARGV[0]; };/s;
	}
    }

    my $tmp = time();

    open(CONF, ">/tmp/$tmp");
    print CONF $lines;
    close(CONF);
	
    rename("/tmp/$tmp", $conf);
    system('/var/www/rpc/surun /etc/init.d/named reload');
			
}
