#!/usr/bin/perl
# How to get extension/mac info from asterisk, with optional arguments:
# /var/adm/bin/show_registration.pl ./sv_config.pl s1019.pbxtra.fonality.com
#
# Added a sort so that a tech can find the extension easier.
# Added \t's for a more readable output.
# 2007-04-25 -bmiller 
#
# Copyright 2007, Fonality Inc. ALL RIGHTS RESERVED.

my(@lines) = `asterisk -r -x "sip show peers"|grep -a OK`;
my(@extens_internal) = `grep -a "Dial.SIP" /etc/asterisk/fonality/internal.conf`;
my(@extens_external) = `grep -a "Dial.SIP" /etc/asterisk/fonality/external.conf`;
my(@extens) = sort(@extens_internal, @extens_external);
my(%macs);
my($prepend) = shift(@ARGV);
my($server) = shift(@ARGV);
$prepend .= ' ' if($prepend);
$server .= ' ' if($server);

foreach $line (@lines) {
	if($line =~ /^(\w{12}).*?\s+(\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3})/) {
		$macs{$1} = $2;
	}
}

foreach $line (@extens) {
	if($line =~ /\s(\d+),2,Dial.SIP\/(\w{12})/) {
		print "${prepend}$macs{$2}\t $2\t ${server}$1\n" if($macs{$2});
	}
}
